Index: /palm/trunk/SOURCE/transpose.f90
===================================================================
--- /palm/trunk/SOURCE/transpose.f90	(revision 4365)
+++ /palm/trunk/SOURCE/transpose.f90	(revision 4366)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! modifications for NEC vectorization
+! 
+! 4360 2020-01-07 11:25:50Z suehring
 ! Added missing OpenMP directives
 ! 
@@ -266,4 +269,7 @@
         ONLY:  cpu_log, cpu_log_nowait, log_point_s
 
+    USE fft_xy,                                                                &
+        ONLY:  f_vec, temperton_fft_vec
+
     USE indices,                                                               &
         ONLY:  nnx, nx, nxl, nxr, nyn, nys, nz
@@ -282,4 +288,5 @@
     INTEGER(iwp) ::  k  !<
     INTEGER(iwp) ::  l  !<
+    INTEGER(iwp) ::  mm !<
     INTEGER(iwp) ::  xs !<
 
@@ -292,31 +299,49 @@
 #endif
 
-
-!
-!-- If the PE grid is one-dimensional along y, the array has only to be
-!-- reordered locally and therefore no transposition has to be done.
+    !
+    !-- If the PE grid is one-dimensional along y, the array has only to be
+    !-- reordered locally and therefore no transposition has to be done.
     IF ( pdims(1) /= 1 )  THEN
 
 #if defined( __parallel )
 !
-!--    Reorder input array for transposition
-!$OMP  PARALLEL PRIVATE ( i, j, k, l, xs )
-       DO  l = 0, pdims(1) - 1
-          xs = 0 + l * nnx
-#if __acc_fft_device
-          !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
-          !$ACC PRESENT(work, f_in)
-#endif
-          !$OMP DO
-          DO  k = nzb_x, nzt_x
-             DO  i = xs, xs + nnx - 1
-                DO  j = nys_x, nyn_x
-                   work(j,i-xs+1,k,l) = f_in(i,j,k)
+!--    Reorder input array for transposition. Data from the vectorized Temperton-fft is stored in
+!--    different array format (f_vec).
+       IF ( temperton_fft_vec )  THEN
+
+          DO  l = 0, pdims(1) - 1
+             xs = 0 + l * nnx
+             DO  k = nzb_x, nzt_x
+                DO  i = xs, xs + nnx - 1
+                   DO  j = nys_x, nyn_x
+                      mm = j-nys_x+1+(k-nzb_x)*(nyn_x-nys_x+1)
+                      work(j,i-xs+1,k,l) = f_vec(mm,i)
+                   ENDDO
                 ENDDO
              ENDDO
           ENDDO
-          !$OMP END DO NOWAIT
-       ENDDO
-!$OMP  END PARALLEL
+
+       ELSE
+
+          !$OMP  PARALLEL PRIVATE ( i, j, k, l, xs )
+          DO  l = 0, pdims(1) - 1
+             xs = 0 + l * nnx
+#if __acc_fft_device
+             !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
+             !$ACC PRESENT(work, f_in)
+#endif
+             !$OMP DO
+             DO  k = nzb_x, nzt_x
+                DO  i = xs, xs + nnx - 1
+                   DO  j = nys_x, nyn_x
+                      work(j,i-xs+1,k,l) = f_in(i,j,k)
+                   ENDDO
+                ENDDO
+             ENDDO
+             !$OMP END DO NOWAIT
+          ENDDO
+          !$OMP  END PARALLEL
+
+       ENDIF
 
 !
@@ -836,4 +861,7 @@
         ONLY:  cpu_log, cpu_log_nowait, log_point_s
 
+    USE fft_xy,                                                                &
+        ONLY:  f_vec, temperton_fft_vec
+
     USE indices,                                                               &
         ONLY:  nnx, nx, nxl, nxr, nyn, nys, nz
@@ -852,4 +880,5 @@
     INTEGER(iwp) ::  k  !<
     INTEGER(iwp) ::  l  !<
+    INTEGER(iwp) ::  mm !<
     INTEGER(iwp) ::  xs !<
 
@@ -914,24 +943,44 @@
 
 !
-!--    Reorder transposed array
-!$OMP  PARALLEL PRIVATE ( i, j, k, l, xs )
-       DO  l = 0, pdims(1) - 1
-          xs = 0 + l * nnx
-#if __acc_fft_device
-          !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
-          !$ACC PRESENT(f_out, work)
-#endif
-          !$OMP DO
-          DO  k = nzb_x, nzt_x
-             DO  i = xs, xs + nnx - 1
-                DO  j = nys_x, nyn_x
-                   f_out(i,j,k) = work(j,i-xs+1,k,l)
+!--    Reorder transposed array.
+!--    Data for the vectorized Temperton-fft is stored in different array format (f_vec) which saves
+!--    additional data copy in fft_x.
+       IF ( temperton_fft_vec )  THEN
+
+          DO  l = 0, pdims(1) - 1
+             xs = 0 + l * nnx
+             DO  k = nzb_x, nzt_x
+                DO  i = xs, xs + nnx - 1
+                   DO  j = nys_x, nyn_x
+                      mm = j-nys_x+1+(k-nzb_x)*(nyn_x-nys_x+1)
+                      f_vec(mm,i) = work(j,i-xs+1,k,l)
+                   ENDDO
                 ENDDO
              ENDDO
           ENDDO
-          !$OMP END DO NOWAIT
-       ENDDO
-!$OMP  END PARALLEL
-#endif
+
+       ELSE
+
+          !$OMP  PARALLEL PRIVATE ( i, j, k, l, xs )
+          DO  l = 0, pdims(1) - 1
+             xs = 0 + l * nnx
+#if __acc_fft_device
+             !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
+             !$ACC PRESENT(f_out, work)
+#endif
+             !$OMP DO
+             DO  k = nzb_x, nzt_x
+                DO  i = xs, xs + nnx - 1
+                   DO  j = nys_x, nyn_x
+                      f_out(i,j,k) = work(j,i-xs+1,k,l)
+                   ENDDO
+                ENDDO
+             ENDDO
+             !$OMP END DO NOWAIT
+          ENDDO
+          !$OMP  END PARALLEL
+#endif
+
+       ENDIF
 
     ENDIF
